﻿    <script src="jquery-1.4.1.min.js" type="text/javascript"></script>

    <script language="javascript" type="text/javascript">

        ////////////////////////
        // Simple Examples
        ////////////////////////
        function Button1_onclick() {

            $(function () {

                //GET
                $.ajax({
                    type: "GET",


                    //////////////////////////
                    //BookSales test examples
                    //////////////////////////

                    //normal single node system (non-distributed) get that only gets this local node's data
                    //url: 'http://localhost/MapReducePortal/BookSales',

                    //simple distributed get example with no fields (properties) specified for the reduce,
                    //which will give us everything from all the nodes, minus any duplicates (which is only
                    //when ALL properties on object match)                    
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3',

                    //example showing control over inclusion of local node's data
                    //(local node's data is always included, unless specifically excluded)
                    //(i.e. if localdata= is not inluded in query string, default is to include local node's data)                    
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&localdata=false',

                    //sum examples
                    url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales',

                    //sort examples
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&sort=ISBN',
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&sortdesc=ISBN',
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&sortasc=BookName',

                    //filter examples (where clause)
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&where=Sales>=10&sort=ISBN',
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&where=ID!=2&sort=ISBN',
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&where=ID!=2,and ID!=3&sort=ISBN',
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&where=ID==2,or ID==4,or BookName==Book C&sort=ISBN',
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&where=Sales>=10&sort=ISBN',
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&where=Sales>=10, and PublishDate>=4/1/2012 12:00:00 AM&sort=ISBN',
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&where=Sales>=10,and PublishDate>=4/1/2012 12:00:00 AM,and ISBN==33333333-3333-3333-3333-333333333333',

                    //error handling test examples
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN2',
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&reduce=PublishDateFilter2',

                    //custom reduce function examples
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&reduce=PublishDateFilter',
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&reduce=PublishDateFilter&sort=ID',
                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&reduce=PublishDateFilter&union=BookName&sum=Sales&sort=ID',

                    //rpc style REST
                    //(these simulate getting the total sales of a given book for EACH individual book store in a chain of book stores, Node1 is book store 1, Node2 is book store 2, etc)
                    //(a report could show each stores total sales of a given book)
                    //url: 'http://localhost/MapReducePortal/BookSales/GetTotalBookSalesByBookName/Book A?distributednodes=Node1,Node2,Node3',
                    //url: 'http://localhost/MapReducePortal/BookSales/GetTotalBookSalesByBookName/Book B?distributednodes=Node1,Node2,Node3',
                    //url: 'http://localhost/MapReducePortal/BookSales/GetTotalBookSalesByBookName/Book C?distributednodes=Node1,Node2,Node3',
                    //url: 'http://localhost/MapReducePortal/BookSales/GetTotalBookSalesByBookName/Book D?distributednodes=Node1,Node2,Node3',
                    //url: 'http://localhost/MapReducePortal/BookSales/GetTotalBookSalesByBookName/Book E?distributednodes=Node1,Node2,Node3',
                    //(these simulate the summing of all the total sales of a given book for ALL stores at the main central corporate office)
                    //(a central master report could show the total sales of a given book accross the entire corporation)
                    //url: 'http://localhost/MapReducePortal/BookSales/GetTotalBookSalesByBookName/Book A?distributednodes=Node1,Node2,Node3&union=BookName&sum=Sales',
                    //url: 'http://localhost/MapReducePortal/BookSales/GetTotalBookSalesByBookName/Book B?distributednodes=Node1,Node2,Node3&union=BookName&sum=Sales',
                    //url: 'http://localhost/MapReducePortal/BookSales/GetTotalBookSalesByBookName/Book C?distributednodes=Node1,Node2,Node3&union=BookName&sum=Sales',
                    //url: 'http://localhost/MapReducePortal/BookSales/GetTotalBookSalesByBookName/Book D?distributednodes=Node1,Node2,Node3&union=BookName&sum=Sales',
                    //url: 'http://localhost/MapReducePortal/BookSales/GetTotalBookSalesByBookName/Book E?distributednodes=Node1,Node2,Node3&union=BookName&sum=Sales',



                    //////////////////////////
                    //Alarm test examples
                    //////////////////////////

                    //normal single node system (non-distributed) get that only gets this local node's data
                    //url: 'http://localhost/MapReducePortal/Alarms',

                    //simple distributed get examples with no fields (properties) specified for the reduce,
                    //which will give us everything from all the nodes, minus any duplicates (which is only
                    //when ALL properties on object match)
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3',

                    //example showing control over inclusion of local node's data
                    //(local node's data is always included, unless specifically excluded)
                    //(i.e. if localdata= is not inluded in query string, default is to include local node's data)
                    //url: 'http://localhost/MapReducePortal/Alarms?localdata=false&distributednodes=Node1',

                    //union examples
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1&union=CreateDate',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid,CreateDate',

                    //sort examples
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=CreateDate&sort=AlarmID',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=CreateDate&sortasc=AlarmID',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=CreateDate&sortdesc=AlarmID',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid&sortasc=AlarmDuration',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid&sortdesc=AlarmDuration',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid&sortasc=CreateDate',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid&sortdesc=CreateDate',

                    //sum examples (1 field sum)
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1&union=AlarmGuid',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1&union=AlarmGuid&sum=AlarmDuration',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2&union=AlarmGuid&sum=AlarmDuration&sortasc=CreateDate',

                    //sum examples (1 field sum)
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&sum=Count&sort=CreateDate',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=Severity&sum=Count&sort=CreateDate',

                    //sum examples (2 fields sum)
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid&sum=AlarmDuration,AlarmID&sortasc=CreateDate',

                    //filter examples (where clause)
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid&sum=AlarmDuration&sort=CreateDate',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid&sum=AlarmDuration&where=AlarmDuration>10&sort=CreateDate',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid&sum=AlarmDuration&where=Severity==Critical,and CreateDate<4/1/2012 12:00:00 AM&sort=CreateDate',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&where=Severity==Critical,and CreateDate<4/1/2012 12:00:00 AM&sort=CreateDate',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&where=Severity==Major,or Severity==Warning,and AlarmDuration>3&sort=CreateDate',

                    //error handling test examples
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid&sum=CreateDate&sortasc=CreateDate',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2&union=AlarmGuid2',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2&reduce=AlarmSeverityFilter2',

                    //custom reduce function examples
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1&reduce=AlarmDurationThreshold&sortasc=AlarmID',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&reduce=AlarmDurationThreshold&sortasc=AlarmID',

                    //custom reduce function examples
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1&reduce=AlarmSeverityFilter&sortasc=AlarmID',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1&reduce=AlarmSeverityFilter&union=AlarmGuid&sort=AlarmID',
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1&reduce=AlarmSeverityFilter&union=AlarmGuid&sum=Count&sort=AlarmID',

                    //intersect examples
                    //(intersect operation should only have ONE node in distributed nodes list in order to make
                    //any sense, if want to do operation on multiple nodes then chain ajax calls that have only
                    //ONE node in list together, see chaining example)
                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1&intersect=CreateDate&sortdesc=AlarmID',

                    //These examples are just to make sure the URITemplate's are working:
                    //url: 'http://localhost/MapReducePortal/Alarms/1?distributednodes=Node1,Node2,Node3',
                    //url: 'http://localhost/MapReducePortal/Alarms/1/alarm1?distributednodes=Node1,Node2,Node3',
                    //url: 'http://localhost/MapReducePortal/Alarms/1/alarm1/11111111-1111-1111-1111-111111111111?distributednodes=Node1,Node2,Node3',
                    //test with error on Node3
                    //url: 'http://localhost/MapReducePortal/Alarms/1/alarm1/11111111-1111-1111-1111-111111111111/1.1?distributednodes=Node1,Node2,Node3',
                    //rpc style REST
                    //url: 'http://localhost/MapReducePortal/Alarms/GetByGuid/11111111-1111-1111-1111-111111111111?distributednodes=Node1,Node2,Node3',



                    //////////////////////////
                    //"Hello World" example
                    //////////////////////////

                    //famous "Hello World" example
                    //url: 'http://localhost/MapReducePortal/WordCount/Test.txt?distributednodes=Node1,Node2,Node3',
                    //url: 'http://localhost/MapReducePortal/WordCount/Test.txt?distributednodes=Node1,Node2,Node3&union=Word&sum=Count',



                    data: '',
                    contentType: 'application/json; charset=utf-8',
                    dataType: 'json',
                    success: function (data, val1, val2) {
                        var output = BuildTable(data);
                        $('#div1').html(output[0]);

                        $('#divErrors').hide();
                        if (output[1] != null) {
                            $('#divErrors').show();
                            $('#divErrors').html(output[1]);
                        }
                    },
                    error: function (data) {
                        $('#b1').html(data.responseText);
                        alert("Error");
                    }
                });
            });
        }

        ////////////////////////
        // Chaining Example
        ////////////////////////
        function Button2_onclick() {

            //////////////////////////////////
            //This shows how can chain ajax calls together.
            //(First GET ajax call is a simple intersect of two sets from two nodes,
            //then second POST ajax call sends in result of first intersect ajax call
            //which does union with the sets from several more nodes.)
            //////////////////////////////////

            $(function () {

                //GET
                $.ajax({
                    type: "GET",
                    url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1&intersect=CreateDate&sortdesc=AlarmID',
                    data: '',
                    contentType: 'application/json; charset=utf-8',
                    dataType: 'json',
                    success: function (data) {

                        //POST
                        $.ajax({
                            type: "POST",
                            url: 'http://localhost/MapReducePortal/Alarms?localdata=false&distributednodes=Node2,Node3&union=AlarmGuid',
                            //data: JSON.stringify(data),  //if newer browser
                            data: stringifyJSON(data),
                            contentType: 'application/json; charset=utf-8',
                            dataType: 'json',
                            success: function (data) {
                                var output = BuildTable(data);
                                $('#div1').html(output[0]);

                                $('#divErrors').hide();
                                if (output[1] != null) {
                                    $('#divErrors').show();
                                    $('#divErrors').html(output[1]);
                                }
                            },
                            error: function (data) {
                                $('#b1').html(data.responseText);
                                alert("Error - POST");
                            }
                        });

                    },
                    error: function (data) {
                        $('#b1').html(data.responseText);
                        alert("Error - GET");
                    }
                });
            });
        }

        ////////////////////////
        // Workflow Example
        ////////////////////////
        function Button3_onclick() {

            //////////////////////////////////
            //This shows how can chain ajax calls together to simulate multi-step workflows (like a
            //larger version of the ASP.NET Pipeline spanning MULTIPLE MACHINES instead of just MULTIPLE
            //CPU PROCESSORS on the same machine.)
            //
            //(First GET ajax call is Step1 in workflow, second through fifth POST ajax calls
            //are Step2-Step6 in workflow. Each steps ajax call is being made to a different node,
            //and the results from the previous steps ajax call is being passed into the next steps ajax call.)
            //
            //To say it another way, if we use a different node for each step in the workflow we can
            //basically create what could be thought of as a larger version of the ASP.NET Pipeline, where
            //each step in the workflow (pipeline) executes asynchronously but does not move to the next step
            //until the previous step has completed. (i.e. The ASP.NET Pipeline can execute each of its steps
            //asynchronously by using separate threads for each step in its pipeline. Those threads basically
            //scale by running on different CPU processors, but are on the same machine. By making a multi-step
            //workflow (pipeline) we can basically execute each step in the workflow (pipeline) asynchronously
            //by using a separate machine for each step in the workflow (pipeline). That basically
            //allows us to scale to the next level by scaling across MULTIPLE MACHINES, not just MULTIPLE
            //CPU PROCESSORS on the same machine.)
            //////////////////////////////////

            $(function () {

                //GET    
                $.ajax({
                    type: "GET",
                    url: 'http://localhost/MapReducePortal/CheeseBurgerWorkflow/Step1',
                    data: '',
                    contentType: 'application/json; charset=utf-8',
                    dataType: 'json',
                    success: function (data) {

                        //POST
                        $.ajax({
                            type: "POST",
                            url: 'http://localhost/MapReducePortal/CheeseBurgerWorkflow/Step2?localdata=false&distributednodes=Node1',
                            //data: JSON.stringify(data),  //if newer browser
                            data: stringifyJSON(data),
                            contentType: 'application/json; charset=utf-8',
                            dataType: 'json',
                            success: function (data) {

                                //POST
                                $.ajax({
                                    type: "POST",
                                    url: 'http://localhost/MapReducePortal/CheeseBurgerWorkflow/Step3?localdata=false&distributednodes=Node2',
                                    //data: JSON.stringify(data),  //if newer browser
                                    data: stringifyJSON(data),
                                    contentType: 'application/json; charset=utf-8',
                                    dataType: 'json',
                                    success: function (data) {

                                        //POST
                                        $.ajax({
                                            type: "POST",
                                            url: 'http://localhost/MapReducePortal/CheeseBurgerWorkflow/Step4?localdata=false&distributednodes=Node3',
                                            //data: JSON.stringify(data),  //if newer browser
                                            data: stringifyJSON(data),
                                            contentType: 'application/json; charset=utf-8',
                                            dataType: 'json',
                                            success: function (data) {

                                                //POST
                                                $.ajax({
                                                    type: "POST",
                                                    url: 'http://localhost/MapReducePortal/CheeseBurgerWorkflow/Step5?localdata=false&distributednodes=Node1',
                                                    //data: JSON.stringify(data),  //if newer browser
                                                    data: stringifyJSON(data),
                                                    contentType: 'application/json; charset=utf-8',
                                                    dataType: 'json',
                                                    success: function (data) {

                                                        //POST
                                                        $.ajax({
                                                            type: "POST",
                                                            url: 'http://localhost/MapReducePortal/CheeseBurgerWorkflow/Step6?localdata=false&distributednodes=Node2',
                                                            //data: JSON.stringify(data),  //if newer browser
                                                            data: stringifyJSON(data),
                                                            contentType: 'application/json; charset=utf-8',
                                                            dataType: 'json',
                                                            success: function (data) {

                                                                //RESULTS
                                                                var output = BuildTable(data);
                                                                $('#div1').html(output[0]);

                                                                $('#divErrors').hide();
                                                                if (output[1] != null) {
                                                                    $('#divErrors').show();
                                                                    $('#divErrors').html(output[1]);
                                                                }

                                                            },
                                                            error: function (data) {
                                                                $('#b1').html(data.responseText);
                                                                alert("Error - Step6");
                                                            }
                                                        });

                                                    },
                                                    error: function (data) {
                                                        $('#b1').html(data.responseText);
                                                        alert("Error - Step5");
                                                    }
                                                });

                                            },
                                            error: function (data) {
                                                $('#b1').html(data.responseText);
                                                alert("Error  - Step4");
                                            }
                                        });

                                    },
                                    error: function (data) {
                                        $('#b1').html(data.responseText);
                                        alert("Error  - Step3");
                                    }
                                });

                            },
                            error: function (data) {
                                $('#b1').html(data.responseText);
                                alert("Error - Step2");
                            }
                        });

                    },
                    error: function (data) {
                        $('#b1').html(data.responseText);
                        alert("Error - Step1");
                    }
                });
            });
        }


        //////////////////////////////////
        //This builds a table the easy way using JQuery.
        //////////////////////////////////
        function BuildTable(data) {
            var ret = Array();
            if (data == null || data.length == 0) {
                ret[0] = "<p>No data.</p>";
                return ret;
            } else {
                var table = $("<table style=\"border-collapse:collapse;\" />");
                var tableError = null;
                $.each(data, function (rowIndex, rowValue) {
                    if (rowValue["Errors"]) {
                        tableError = $("<table style=\"border-collapse:collapse;\"><caption align=\"left\" style=\"color: #4b6c9e;\"><b>Errors on nodes:</b></caption>");
                        $.each(rowValue["Errors"], function (errorIndex, errorObject) {
                            var trError = $("<tr/>");
                            if (errorIndex == 0) {
                                $.each(errorObject, function (errorKey, errorValue) {
                                    trError.append($("<th scope=\"col\" style=\"border: 1px solid #909090;color: #4b6c9e;background: #eeeeee;\" nowrap=\"nowrap\" />").text(errorKey));
                                });
                                tableError.append(trError);
                            }
                            trError = $("<tr/>");
                            $.each(errorObject, function (errorKey, errorValue) {
                                trError.append($("<td nowrap=\"nowrap\" />").text(errorValue));
                            });
                            tableError.append(trError);
                        });
                    } else {
                        var tr = $("<tr/>");
                        if (rowIndex == 0) {
                            $.each(rowValue, function (colKey, colValue) {
                                tr.append($("<th scope=\"col\" style=\"border: 1px solid #909090;color: #4b6c9e;background: #eeeeee;\" nowrap=\"nowrap\" />").text(colKey));
                            });
                            table.append(tr);
                        }
                        tr = $("<tr/>");
                        $.each(rowValue, function (colKey, colValue) {
                            tr.append($("<td nowrap=\"nowrap\" />").text(colValue));
                        });
                        table.append(tr);
                    }
                });

                //return data table
                ret[0] = table;

                //return error table
                if (tableError != null) {
                    ret[1] = tableError;
                }
            }
            return ret;
        };


        //////////////////////////////////
        //This stringify's JSON for older browsers that don't have JSON.stringify built-in.
        //(If using newer browser use JSON.stringify instead.)
        //////////////////////////////////
        function stringifyJSON(data) {
            var x1 = 0;
            if (typeof (data) != "object" || data === null) {
                if (typeof (data) == "string") {
                    data = data.replace('/Date', '\\/Date');
                    data = data.replace(')/', ')\\/');
                    data = '"' + data + '"';
                }
                return String(data);
            } else {
                var array = (data && data.constructor == Array);
                var json = [];
                $.each(data, function (key, value) {
                    if (data.hasOwnProperty(key)) {
                        if (typeof (value) == "string") {
                            value = value.replace('/Date', '\\/Date');
                            value = value.replace(')/', ')\\/');
                            value = '"' + value + '"';
                        } else if (typeof (value) == "object" && value != null) {
                            value = stringifyJSON(value);
                        }
                        json.push((array ? "" : '"' + key + '":') + String(value));
                    }
                });
                return (array ? "[" : "{") + String(json) + (array ? "]" : "}");
            }
        };

    </script>

<html>
  <head></head>
  <body>
    <h1>REST MapReduce Tester</h1>
    <h2>
      <input id="Button1" type="button" value="Test (GET)" onclick="return Button1_onclick()" />
      <input id="Button2" type="button" value="Test Chaining (POST)" onclick="return Button2_onclick()" />
      <input id="Button3" type="button" value="Test Workflow (POST)" onclick="return Button3_onclick()" />
    </h2>

    <br />
    <div id="div1"></div>
    <br />
    <div id="divErrors" style="display: none;"></div>
  </body>
</html>
